﻿using System;
using System.Windows;
using System.ComponentModel;

namespace WpfTextBoxValidation
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Person p = new Person();
            PersonViewModel pvm = new PersonViewModel() { Person = p };
            MainGrid.DataContext = pvm;
        }
    }

    public class Person
    {
        public String FirstName { get; set; }
        public String LastName { get; set; }
        public int Age { get; set; }
        public String Phone { get; set; }
    }

    public class PersonViewModel : INotifyPropertyChanged
    {
        public Person Person
        {
            get { return _Person; }
            set { _Person = value; ;}
        } private Person _Person;

        public String FirstName
        {
            get { return Person.FirstName; }
            set
            {
                Person.FirstName = value;
                NotifyPropertyChanged("FirstName");
            }
        }

        public String LastName
        {
            get { return Person.LastName; }
            set
            {
                Person.LastName = value;
                NotifyPropertyChanged("LastName");
            }
        }
        
        public int Age
        {
            get { return Person.Age; }
            set
            {
                Person.Age = value;
                NotifyPropertyChanged("Age");
            }
        }
        
        public String Phone
        {
            get { return Person.Phone; }
            set
            {
                Person.Phone = value;
                NotifyPropertyChanged("Phone");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void NotifyPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                var e = new PropertyChangedEventArgs(propertyName);
                handler(this, e);
            }
        }
    }
}
